class
	SD_ADDRINFO

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			make_shared,
			structure_size,
			offset_of,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			internal_c_pointer := internal_c_pointer.memory_alloc (structure_size)
			is_allocated_memory := True
		end

	make_shared (a_c_pointer: POINTER)
		do
			internal_c_pointer := a_c_pointer
		end

	make_initialized (a_data: TUPLE [
				a_ai_flags: INTEGER_32
				a_ai_family: INTEGER_32
				a_ai_socktype: INTEGER_32
				a_ai_protocol: INTEGER_32
				a_ai_addrlen: NATURAL_32
				a_ai_addr: CE_POINTER [SD_SOCKADDR]
				a_ai_canonname: CE_POINTER [INTEGER_8]
				a_ai_next: CE_POINTER [SD_ADDRINFO]
			])
		require else
			a_data /= Void
		do
			make
			Current.ai_flags := a_data.a_ai_flags
			Current.ai_family := a_data.a_ai_family
			Current.ai_socktype := a_data.a_ai_socktype
			Current.ai_protocol := a_data.a_ai_protocol
			Current.ai_addrlen := a_data.a_ai_addrlen
			Current.ai_addr := a_data.a_ai_addr
			Current.ai_canonname := a_data.a_ai_canonname
			Current.ai_next := a_data.a_ai_next
		end

feature {ANY} -- fields

	ai_flags: INTEGER_32 assign set__ai_flags
		do
			Result := c__ai_flags (internal_c_pointer)
		end

	ai_family: INTEGER_32 assign set__ai_family
		do
			Result := c__ai_family (internal_c_pointer)
		end

	ai_socktype: INTEGER_32 assign set__ai_socktype
		do
			Result := c__ai_socktype (internal_c_pointer)
		end

	ai_protocol: INTEGER_32 assign set__ai_protocol
		do
			Result := c__ai_protocol (internal_c_pointer)
		end

	ai_addrlen: NATURAL_32 assign set__ai_addrlen
		do
			Result := c__ai_addrlen (internal_c_pointer)
		end

	ai_addr: CE_POINTER [SD_SOCKADDR] assign set__ai_addr
		do
			create {CE_CLASS_POINTER [SD_SOCKADDR]} Result.make_shared (c__ai_addr (internal_c_pointer))
		end

	ai_canonname: CE_POINTER [INTEGER_8] assign set__ai_canonname
		do
			create {CE_INTEGER_8_POINTER} Result.make_shared (c__ai_canonname (internal_c_pointer))
		end

	ai_next: CE_POINTER [SD_ADDRINFO] assign set__ai_next
		do
			create {CE_CLASS_POINTER [SD_ADDRINFO]} Result.make_shared (c__ai_next (internal_c_pointer))
		end

feature {ANY} -- field setters

	set__ai_flags (a_ai_flags: INTEGER_32)
		do
			c__set_ai_flags (internal_c_pointer, a_ai_flags)
		end

	set__ai_family (a_ai_family: INTEGER_32)
		do
			c__set_ai_family (internal_c_pointer, a_ai_family)
		end

	set__ai_socktype (a_ai_socktype: INTEGER_32)
		do
			c__set_ai_socktype (internal_c_pointer, a_ai_socktype)
		end

	set__ai_protocol (a_ai_protocol: INTEGER_32)
		do
			c__set_ai_protocol (internal_c_pointer, a_ai_protocol)
		end

	set__ai_addrlen (a_ai_addrlen: NATURAL_32)
		do
			c__set_ai_addrlen (internal_c_pointer, a_ai_addrlen)
		end

	set__ai_addr (a_ai_addr: CE_POINTER [SD_SOCKADDR])
		do
			c__set_ai_addr (internal_c_pointer, a_ai_addr.c_pointer)
		end

	set__ai_canonname (a_ai_canonname: CE_POINTER [INTEGER_8])
		do
			c__set_ai_canonname (internal_c_pointer, a_ai_canonname.c_pointer)
		end

	set__ai_next (a_ai_next: CE_POINTER [SD_ADDRINFO])
		do
			c__set_ai_next (internal_c_pointer, a_ai_next.c_pointer)
		end

feature {ANY}

	structure_size: INTEGER_32
		external
			"C inline use %"libmongo.h%""
		alias
			"return sizeof(struct addrinfo);"
		end

	structure_alignment: INTEGER_32
		external
			"C inline use %"libmongo.h%""
		alias
			"return __alignof__(struct addrinfo);"
		end

	offset_of (a_field_name: STRING_8): INTEGER_32
		local
			l_c_str: C_STRING
		do
			create l_c_str.make (a_field_name)
			Result := c__offset_of (l_c_str.item)
		end

feature {ANY}

	copy (a_other: like Current)
		do
			make
			internal_c_pointer.memory_copy (a_other.c_pointer, structure_size)
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result := internal_c_pointer.memory_compare (a_other.c_pointer, structure_size)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		do
			-- dummy for CE_CLASS invariant
			create Result.make_struct (<<>>)
			Result.alignment := structure_alignment
		end

	c__ai_flags (a_c_pointer: POINTER): INTEGER_32
		external
			"C inline use %"libmongo.h%""
		alias
			"return ((struct addrinfo *)$a_c_pointer)->ai_flags;"
		end

	c__ai_family (a_c_pointer: POINTER): INTEGER_32
		external
			"C inline use %"libmongo.h%""
		alias
			"return ((struct addrinfo *)$a_c_pointer)->ai_family;"
		end

	c__ai_socktype (a_c_pointer: POINTER): INTEGER_32
		external
			"C inline use %"libmongo.h%""
		alias
			"return ((struct addrinfo *)$a_c_pointer)->ai_socktype;"
		end

	c__ai_protocol (a_c_pointer: POINTER): INTEGER_32
		external
			"C inline use %"libmongo.h%""
		alias
			"return ((struct addrinfo *)$a_c_pointer)->ai_protocol;"
		end

	c__ai_addrlen (a_c_pointer: POINTER): NATURAL_32
		external
			"C inline use %"libmongo.h%""
		alias
			"return ((struct addrinfo *)$a_c_pointer)->ai_addrlen;"
		end

	c__ai_addr (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"libmongo.h%""
		alias
			"return (EIF_POINTER)((struct addrinfo *)$a_c_pointer)->ai_addr;"
		end

	c__ai_canonname (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"libmongo.h%""
		alias
			"return (EIF_POINTER)((struct addrinfo *)$a_c_pointer)->ai_canonname;"
		end

	c__ai_next (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"libmongo.h%""
		alias
			"return (EIF_POINTER)((struct addrinfo *)$a_c_pointer)->ai_next;"
		end

	c__set_ai_flags (a_c_pointer: POINTER; a_ai_flags: INTEGER_32)
		external
			"C inline use %"libmongo.h%""
		alias
			"((struct addrinfo *)$a_c_pointer)->ai_flags = $a_ai_flags;"
		end

	c__set_ai_family (a_c_pointer: POINTER; a_ai_family: INTEGER_32)
		external
			"C inline use %"libmongo.h%""
		alias
			"((struct addrinfo *)$a_c_pointer)->ai_family = $a_ai_family;"
		end

	c__set_ai_socktype (a_c_pointer: POINTER; a_ai_socktype: INTEGER_32)
		external
			"C inline use %"libmongo.h%""
		alias
			"((struct addrinfo *)$a_c_pointer)->ai_socktype = $a_ai_socktype;"
		end

	c__set_ai_protocol (a_c_pointer: POINTER; a_ai_protocol: INTEGER_32)
		external
			"C inline use %"libmongo.h%""
		alias
			"((struct addrinfo *)$a_c_pointer)->ai_protocol = $a_ai_protocol;"
		end

	c__set_ai_addrlen (a_c_pointer: POINTER; a_ai_addrlen: NATURAL_32)
		external
			"C inline use %"libmongo.h%""
		alias
			"((struct addrinfo *)$a_c_pointer)->ai_addrlen = $a_ai_addrlen;"
		end

	c__set_ai_addr (a_c_pointer: POINTER; a_ai_addr: POINTER)
		external
			"C inline use %"libmongo.h%""
		alias
			"((struct addrinfo *)$a_c_pointer)->ai_addr = $a_ai_addr;"
		end

	c__set_ai_canonname (a_c_pointer: POINTER; a_ai_canonname: POINTER)
		external
			"C inline use %"libmongo.h%""
		alias
			"((struct addrinfo *)$a_c_pointer)->ai_canonname = $a_ai_canonname;"
		end

	c__set_ai_next (a_c_pointer: POINTER; a_ai_next: POINTER)
		external
			"C inline use %"libmongo.h%""
		alias
			"((struct addrinfo *)$a_c_pointer)->ai_next = $a_ai_next;"
		end

	c__offset_of (a_field_name: POINTER): INTEGER_32
		external
			"C inline use %"libmongo.h%", <string.h>, <stddef.h>, <stdio.h>"
		alias
			"[
				if(strcmp($a_field_name, "ai_flags") == 0) return offsetof(struct addrinfo, ai_flags);
				if(strcmp($a_field_name, "ai_family") == 0) return offsetof(struct addrinfo, ai_family);
				if(strcmp($a_field_name, "ai_socktype") == 0) return offsetof(struct addrinfo, ai_socktype);
				if(strcmp($a_field_name, "ai_protocol") == 0) return offsetof(struct addrinfo, ai_protocol);
				if(strcmp($a_field_name, "ai_addrlen") == 0) return offsetof(struct addrinfo, ai_addrlen);
				if(strcmp($a_field_name, "ai_addr") == 0) return offsetof(struct addrinfo, ai_addr);
				if(strcmp($a_field_name, "ai_canonname") == 0) return offsetof(struct addrinfo, ai_canonname);
				if(strcmp($a_field_name, "ai_next") == 0) return offsetof(struct addrinfo, ai_next);
				fprintf(stderr, "struct addrinfo.%s not found\n", (char *)$a_field_name);
				return -1;
			]"
		end

end
