class
	P_SRC_GRIDFS_STATIC

inherit
	CE_UTILITIES
	S_STDLIB_STATIC
	S_STRING_STATIC
	S_STDIO_STATIC

feature {ANY} -- public routines

	gridfs_create: CE_POINTER [PD_GRIDFS]
		do
			Result := (create {CE_CLASS_POINTER [PD_GRIDFS]}.make_cast (((create {P_SRC_BSON_STATIC}).bson_malloc (((create {PD_GRIDFS}.make).structure_size.to_natural_32).to_integer_32))))
		end

	gridfs_dispose (a_gfs: CE_POINTER [PD_GRIDFS])
		do
			free (create {CE_VOID_POINTER}.make_cast (a_gfs))
		end

	gridfile_create: CE_POINTER [PD_GRIDFILE]
		do
			Result := (create {CE_CLASS_POINTER [PD_GRIDFILE]}.make_cast (((create {P_SRC_BSON_STATIC}).bson_malloc (((create {PD_GRIDFILE}.make).structure_size.to_natural_32).to_integer_32))))
		end

	gridfile_dispose (a_gf: CE_POINTER [PD_GRIDFILE])
		do
			free (create {CE_VOID_POINTER}.make_cast (a_gf))
		end

	chunk_new (a_id: PD_BSON_OID_T; a_chunk_number: INTEGER_32; a_data_0: CE_POINTER [INTEGER_8]; a_len: INTEGER_32): CE_POINTER [PD_BSON]
		local
			l_id: CE_ARRAY [PD_BSON_OID_T]
			l_b: CE_POINTER [PD_BSON]
		do
			create {CE_CLASS_ARRAY [PD_BSON_OID_T]} l_id.make (<<1>>)

			l_id.item := a_id.twin
			l_b := create {CE_CLASS_POINTER [PD_BSON]}.make_cast (((create {P_SRC_BSON_STATIC}).bson_malloc (((create {PD_BSON}.make).structure_size.to_natural_32).to_integer_32)))
			l_b.item.init
			l_b.item.append_oid (ce_cstring ("files_id"), l_id).do_nothing
			l_b.item.append_int (ce_cstring ("n"), a_chunk_number).do_nothing
			l_b.item.append_binary (ce_cstring ("data"), (0).to_integer_8, a_data_0, a_len).do_nothing
			l_b.item.finish.do_nothing
			Result := l_b
		end

	chunk_free (a_o_chunk: CE_POINTER [PD_BSON])
		do
			a_o_chunk.item.destroy;
			(create {P_SRC_BSON_STATIC}).bson_free (create {CE_VOID_POINTER}.make_cast (a_o_chunk))
		end

	gridfs_init (a_client: CE_POINTER [PD_MONGO]; a_dbname, a_prefix: CE_POINTER [INTEGER_8]; a_gfs: CE_POINTER [PD_GRIDFS]): INTEGER_32
		require
			not a_dbname.is_void
			not a_gfs.is_void
		local
			l_prefix: CE_POINTER [INTEGER_8]
			l_options: INTEGER_32
			l_b: CE_ARRAY [PD_BSON]
			l_success: INTEGER_32
			l_tmp_3: NATURAL_32
			l_tmp_4: NATURAL_32
			l_tmp_7: NATURAL_32
			l_tmp_8: NATURAL_32
			l_return: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_BSON]} l_b.make (<<1>>)

			l_prefix := a_prefix
			a_gfs.item.client := a_client
			a_gfs.item.dbname := create {CE_INTEGER_8_POINTER}.make_cast (((create {P_SRC_BSON_STATIC}).bson_malloc (((strlen (a_dbname)) + {NATURAL_32} 1).to_integer_32)))
			strcpy (a_gfs.item.dbname, a_dbname).do_nothing
			if l_prefix.is_void then
				l_prefix := ce_cstring ("fs")
			end
			a_gfs.item.prefix2 := create {CE_INTEGER_8_POINTER}.make_cast (((create {P_SRC_BSON_STATIC}).bson_malloc (((strlen (l_prefix)) + {NATURAL_32} 1).to_integer_32)))
			strcpy (a_gfs.item.prefix2, l_prefix).do_nothing
			l_tmp_3 := strlen (l_prefix)
			l_tmp_4 := strlen (a_dbname)
			a_gfs.item.files_ns := create {CE_INTEGER_8_POINTER}.make_cast (((create {P_SRC_BSON_STATIC}).bson_malloc ((((l_tmp_3 + l_tmp_4) + (strlen (ce_cstring (".files")))) + {NATURAL_32} 2).to_integer_32)))
			strcpy (a_gfs.item.files_ns, a_dbname).do_nothing
			strcat (a_gfs.item.files_ns, ce_cstring (".")).do_nothing
			strcat (a_gfs.item.files_ns, l_prefix).do_nothing
			strcat (a_gfs.item.files_ns, ce_cstring (".files")).do_nothing
			l_tmp_7 := strlen (l_prefix)
			l_tmp_8 := strlen (a_dbname)
			a_gfs.item.chunks_ns := create {CE_INTEGER_8_POINTER}.make_cast (((create {P_SRC_BSON_STATIC}).bson_malloc ((((l_tmp_7 + l_tmp_8) + (strlen (ce_cstring (".chunks")))) + {NATURAL_32} 2).to_integer_32)))
			strcpy (a_gfs.item.chunks_ns, a_dbname).do_nothing
			strcat (a_gfs.item.chunks_ns, ce_cstring (".")).do_nothing
			strcat (a_gfs.item.chunks_ns, l_prefix).do_nothing
			strcat (a_gfs.item.chunks_ns, ce_cstring (".chunks")).do_nothing
			l_b.item.init
			l_b.item.append_int (ce_cstring ("filename"), 1).do_nothing
			l_b.item.finish.do_nothing
			l_options := 0
			l_success := (((a_gfs.item.client).item.create_index (a_gfs.item.files_ns, l_b, l_options, create {CE_CLASS_POINTER [PD_BSON]}.make_shared (default_pointer))) = 0).to_integer;
			l_b.item.destroy
			if not l_success.to_boolean then
				(create {P_SRC_BSON_STATIC}).bson_free (create {CE_VOID_POINTER}.make_cast (a_gfs.item.dbname));
				(create {P_SRC_BSON_STATIC}).bson_free (create {CE_VOID_POINTER}.make_cast (a_gfs.item.prefix2));
				(create {P_SRC_BSON_STATIC}).bson_free (create {CE_VOID_POINTER}.make_cast (a_gfs.item.files_ns));
				(create {P_SRC_BSON_STATIC}).bson_free (create {CE_VOID_POINTER}.make_cast (a_gfs.item.chunks_ns))
				Result := (-1)
				l_return := True
			end
			if not l_return then
				l_b.item.init
				l_b.item.append_int (ce_cstring ("files_id"), 1).do_nothing
				l_b.item.append_int (ce_cstring ("n"), 1).do_nothing
				l_b.item.finish.do_nothing
				l_options := 1
				l_success := (((a_gfs.item.client).item.create_index (a_gfs.item.chunks_ns, l_b, l_options, create {CE_CLASS_POINTER [PD_BSON]}.make_shared (default_pointer))) = 0).to_integer;
				l_b.item.destroy
				if not l_success.to_boolean then
					(create {P_SRC_BSON_STATIC}).bson_free (create {CE_VOID_POINTER}.make_cast (a_gfs.item.dbname));
					(create {P_SRC_BSON_STATIC}).bson_free (create {CE_VOID_POINTER}.make_cast (a_gfs.item.prefix2));
					(create {P_SRC_BSON_STATIC}).bson_free (create {CE_VOID_POINTER}.make_cast (a_gfs.item.files_ns));
					(create {P_SRC_BSON_STATIC}).bson_free (create {CE_VOID_POINTER}.make_cast (a_gfs.item.chunks_ns))
					Result := (-1)
					l_return := True
				end
			end
			if not l_return then
				Result := 0
			end
		end

	gridfs_destroy (a_gfs: CE_POINTER [PD_GRIDFS])
		local
			l_return: BOOLEAN
		do
			if a_gfs.is_void then
				l_return := True
			end
			if not l_return then
				if (not (a_gfs.item.dbname).is_void) then
					(create {P_SRC_BSON_STATIC}).bson_free (create {CE_VOID_POINTER}.make_cast (a_gfs.item.dbname))
				end
				if (not (a_gfs.item.prefix2).is_void) then
					(create {P_SRC_BSON_STATIC}).bson_free (create {CE_VOID_POINTER}.make_cast (a_gfs.item.prefix2))
				end
				if (not (a_gfs.item.files_ns).is_void) then
					(create {P_SRC_BSON_STATIC}).bson_free (create {CE_VOID_POINTER}.make_cast (a_gfs.item.files_ns))
				end
				if (not (a_gfs.item.chunks_ns).is_void) then
					(create {P_SRC_BSON_STATIC}).bson_free (create {CE_VOID_POINTER}.make_cast (a_gfs.item.chunks_ns))
				end
			end
		end

	gridfs_store_file (a_gfs: CE_POINTER [PD_GRIDFS]; a_filename, a_remotename, a_contenttype: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_remotename: CE_POINTER [INTEGER_8]
			l_buffer: CE_ARRAY [INTEGER_8]
			l_fd: CE_POINTER [SD_IO_FILE]
			l_id: CE_ARRAY [PD_BSON_OID_T]
			l_chunk_number: INTEGER_32
			l_length: NATURAL_64
			l_chunk_len: NATURAL_64
			l_o_chunk: CE_POINTER [PD_BSON]
			l_return, l_break: BOOLEAN
		do
			create {CE_INTEGER_8_ARRAY} l_buffer.make (<<262_144>>)
			create {CE_CLASS_ARRAY [PD_BSON_OID_T]} l_id.make (<<1>>)

			l_remotename := a_remotename
			l_chunk_number := 0
			l_length := (0).to_natural_64
			l_chunk_len := (0).to_natural_64
			if strcmp (a_filename, ce_cstring ("-")) = 0 then
				l_fd := ce_input_file_pointer
			else
				l_fd := fopen (a_filename, ce_cstring ("rb"))
				if l_fd.is_void then
					Result := (-1)
					l_return := True
				end
			end
			if not l_return then
				l_id.item.bson_oid_gen
				l_chunk_len := (fread (create {CE_VOID_POINTER}.make_cast (l_buffer), (1).to_natural_32, (262_144).to_natural_32, l_fd)).to_natural_64
				from
				until
					(l_break)
				loop
					l_break := False
					l_o_chunk := chunk_new ((l_id.item).twin, l_chunk_number, l_buffer, l_chunk_len.to_integer_32);
					a_gfs.item.client.item.insert (a_gfs.item.chunks_ns, l_o_chunk, create {CE_CLASS_POINTER [PD_MONGO_WRITE_CONCERN]}.make_shared (default_pointer)).do_nothing
					chunk_free (l_o_chunk)
					l_length := l_length + l_chunk_len
					l_chunk_number := l_chunk_number + 1
					l_chunk_len := (fread (create {CE_VOID_POINTER}.make_cast (l_buffer), (1).to_natural_32, (262_144).to_natural_32, l_fd)).to_natural_64
					if l_chunk_len = {NATURAL_64} 0 then
						l_break := True
					end
				end
				l_break := False
				if not l_fd.is_equal (ce_input_file_pointer) then
					fclose (l_fd).do_nothing
				end
				if l_remotename.is_void then
					l_remotename := a_filename
				elseif (l_remotename[0]).to_integer_32 = 0 then
					l_remotename := a_filename
				end
				Result := (a_gfs.item.insert_file (l_remotename, (l_id.item).twin, l_length, a_contenttype))
			end
		end

	gridfile_exists (a_gfile: CE_POINTER [PD_GRIDFILE]): INTEGER_32
		local
			l_tmp: INTEGER_32
		do
			if not a_gfile.is_void then
				l_tmp := 1
			elseif (a_gfile.item.meta).is_void then
				l_tmp := 1
			else
				l_tmp := 0
			end
			Result := l_tmp
		end

end
