class
	PD_MONGO

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			make_shared,
			structure_size,
			offset_of,
			copy,
			is_equal
		end
	S_STRING_STATIC
		redefine
			copy,
			is_equal
		end
	S_STDLIB_STATIC
		redefine
			copy,
			is_equal
		end
	P_SRC_MONGO_STATIC
		redefine
			copy,
			is_equal
		end
	P_SRC_ENV_STATIC
		rename
			connect as sys_connect
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			internal_c_pointer := internal_c_pointer.memory_alloc (structure_size)
			is_allocated_memory := True
		end

	make_shared (a_c_pointer: POINTER)
		do
			internal_c_pointer := a_c_pointer
		end

	make_initialized (a_data: TUPLE [
				a_primary: CE_POINTER [PD_MONGO_HOST_PORT]
				a_replset: CE_POINTER [PD_MONGO_REPLSET]
				a_sock: INTEGER_32
				a_flags: INTEGER_32
				a_conn_timeout_ms: INTEGER_32
				a_op_timeout_ms: INTEGER_32
				a_max_bson_size: INTEGER_32
				a_connected: INTEGER_32
				a_write_concern: CE_POINTER [PD_MONGO_WRITE_CONCERN]
				a_err: NATURAL_32
				a_errcode: INTEGER_32
				a_errstr: CE_ARRAY [INTEGER_8]
				a_lasterrcode: INTEGER_32
				a_lasterrstr: CE_ARRAY [INTEGER_8]
			])
		require else
			a_data /= Void
		do
			make
			Current.primary := a_data.a_primary
			Current.replset := a_data.a_replset
			Current.sock := a_data.a_sock
			Current.flags := a_data.a_flags
			Current.conn_timeout_ms := a_data.a_conn_timeout_ms
			Current.op_timeout_ms := a_data.a_op_timeout_ms
			Current.max_bson_size := a_data.a_max_bson_size
			Current.connected := a_data.a_connected
			Current.write_concern := a_data.a_write_concern
			Current.err := a_data.a_err
			Current.errcode := a_data.a_errcode
			errstr.c_pointer.memory_copy (a_data.a_errstr.c_pointer, a_data.a_errstr.total_count * a_data.a_errstr.element_size)
			Current.lasterrcode := a_data.a_lasterrcode
			lasterrstr.c_pointer.memory_copy (a_data.a_lasterrstr.c_pointer, a_data.a_lasterrstr.total_count * a_data.a_lasterrstr.element_size)
		end

feature {ANY} -- fields

	primary: CE_POINTER [PD_MONGO_HOST_PORT] assign set__primary
		do
			create {CE_CLASS_POINTER [PD_MONGO_HOST_PORT]} Result.make_shared (c__primary (internal_c_pointer))
		end

	replset: CE_POINTER [PD_MONGO_REPLSET] assign set__replset
		do
			create {CE_CLASS_POINTER [PD_MONGO_REPLSET]} Result.make_shared (c__replset (internal_c_pointer))
		end

	sock: INTEGER_32 assign set__sock
		do
			Result := c__sock (internal_c_pointer)
		end

	flags: INTEGER_32 assign set__flags
		do
			Result := c__flags (internal_c_pointer)
		end

	conn_timeout_ms: INTEGER_32 assign set__conn_timeout_ms
		do
			Result := c__conn_timeout_ms (internal_c_pointer)
		end

	op_timeout_ms: INTEGER_32 assign set__op_timeout_ms
		do
			Result := c__op_timeout_ms (internal_c_pointer)
		end

	max_bson_size: INTEGER_32 assign set__max_bson_size
		do
			Result := c__max_bson_size (internal_c_pointer)
		end

	connected: INTEGER_32 assign set__connected
		do
			Result := c__connected (internal_c_pointer)
		end

	write_concern: CE_POINTER [PD_MONGO_WRITE_CONCERN] assign set__write_concern
		do
			create {CE_CLASS_POINTER [PD_MONGO_WRITE_CONCERN]} Result.make_shared (c__write_concern (internal_c_pointer))
		end

	err: NATURAL_32 assign set__err
		do
			Result := c__err (internal_c_pointer)
		end

	errcode: INTEGER_32 assign set__errcode
		do
			Result := c__errcode (internal_c_pointer)
		end

	errstr: CE_ARRAY [INTEGER_8]
		once ("OBJECT")
			create {CE_INTEGER_8_ARRAY} Result.make_shared (c__errstr (internal_c_pointer), <<128>>)
		end

	lasterrcode: INTEGER_32 assign set__lasterrcode
		do
			Result := c__lasterrcode (internal_c_pointer)
		end

	lasterrstr: CE_ARRAY [INTEGER_8]
		once ("OBJECT")
			create {CE_INTEGER_8_ARRAY} Result.make_shared (c__lasterrstr (internal_c_pointer), <<128>>)
		end

feature {ANY} -- field setters

	set__primary (a_primary: CE_POINTER [PD_MONGO_HOST_PORT])
		do
			c__set_primary (internal_c_pointer, a_primary.c_pointer)
		end

	set__replset (a_replset: CE_POINTER [PD_MONGO_REPLSET])
		do
			c__set_replset (internal_c_pointer, a_replset.c_pointer)
		end

	set__sock (a_sock: INTEGER_32)
		do
			c__set_sock (internal_c_pointer, a_sock)
		end

	set__flags (a_flags: INTEGER_32)
		do
			c__set_flags (internal_c_pointer, a_flags)
		end

	set__conn_timeout_ms (a_conn_timeout_ms: INTEGER_32)
		do
			c__set_conn_timeout_ms (internal_c_pointer, a_conn_timeout_ms)
		end

	set__op_timeout_ms (a_op_timeout_ms: INTEGER_32)
		do
			c__set_op_timeout_ms (internal_c_pointer, a_op_timeout_ms)
		end

	set__max_bson_size (a_max_bson_size: INTEGER_32)
		do
			c__set_max_bson_size (internal_c_pointer, a_max_bson_size)
		end

	set__connected (a_connected: INTEGER_32)
		do
			c__set_connected (internal_c_pointer, a_connected)
		end

	set__write_concern (a_write_concern: CE_POINTER [PD_MONGO_WRITE_CONCERN])
		do
			c__set_write_concern (internal_c_pointer, a_write_concern.c_pointer)
		end

	set__err (a_err: NATURAL_32)
		do
			c__set_err (internal_c_pointer, a_err)
		end

	set__errcode (a_errcode: INTEGER_32)
		do
			c__set_errcode (internal_c_pointer, a_errcode)
		end

	set__lasterrcode (a_lasterrcode: INTEGER_32)
		do
			c__set_lasterrcode (internal_c_pointer, a_lasterrcode)
		end

feature {ANY} -- public routines

	get_err: INTEGER_32
		do
			Result := err.to_integer_32
		end

	is_connected: INTEGER_32
		do
			Result := (connected /= 0).to_integer
		end

	get_op_timeout: INTEGER_32
		do
			Result := op_timeout_ms
		end

	get_host_count: INTEGER_32
		local
			l_r: CE_POINTER [PD_MONGO_REPLSET]
			l_hp: CE_POINTER [PD_MONGO_HOST_PORT]
			l_count: INTEGER_32
			l_return: BOOLEAN
		do
			l_r := replset
			l_count := 0
			if l_r.is_void then
				Result := 0
				l_return := True
			end
			if not l_return then
				l_hp := l_r.item.hosts
				from
				until
					l_hp.is_void
				loop
					l_count := l_count + 1
					l_hp := l_hp.item.next
				end
				Result := l_count
			end
		end

	get_host (a_i: INTEGER_32): CE_POINTER [INTEGER_8]
		local
			l_r: CE_POINTER [PD_MONGO_REPLSET]
			l_hp: CE_POINTER [PD_MONGO_HOST_PORT]
			l_count: INTEGER_32
			l_return: BOOLEAN
		do
			create {CE_INTEGER_8_POINTER} Result.make

			l_r := replset
			l_count := 0
			if l_r.is_void then
				Result := (create {CE_INTEGER_8_POINTER}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				l_hp := l_r.item.hosts
				from
				until
					not (not (l_return) and then (not l_hp.is_void))
				loop
					if l_count = a_i then
						Result := (l_hp.item.get_host_port)
						l_return := True
					end
					if not l_return then
						l_count := l_count + 1
						l_hp := l_hp.item.next
					end
				end
			end
			if not l_return then
				Result := (create {CE_INTEGER_8_POINTER}.make_shared (default_pointer))
			end
		end

	get_server_err: INTEGER_32
		do
			Result := lasterrcode
		end

	get_server_err_string: CE_POINTER [INTEGER_8]
		do
			Result := lasterrstr
		end

	set_error (a_err: NATURAL_32; a_str: CE_POINTER [INTEGER_8]; a_errcode: INTEGER_32)
		local
			l_errstr_size: INTEGER_32
			l_str_size: INTEGER_32
		do
			Current.err := a_err
			Current.errcode := a_errcode
			if (not a_str.is_void) then
				l_str_size := ((strlen (a_str)) + {NATURAL_32} 1).to_integer_32
				if l_str_size > 128 then
					l_errstr_size := 128
				else
					l_errstr_size := l_str_size
				end
				memcpy (create {CE_VOID_POINTER}.make_cast (errstr), create {CE_VOID_POINTER}.make_cast (a_str), l_errstr_size.to_natural_32).do_nothing
				errstr[l_errstr_size - 1] := (('%/0/').code).to_integer_8
			end
		end

	clear_errors
		do
			Current.err := {PC_MONGO_ERROR_T}.Mongo_conn_success
			Current.errcode := 0
			Current.lasterrcode := 0
			memset (create {CE_VOID_POINTER}.make_cast (errstr), 0, (128).to_natural_32).do_nothing
			memset (create {CE_VOID_POINTER}.make_cast (lasterrstr), 0, (128).to_natural_32).do_nothing
		end

	set_last_error (a_it: CE_POINTER [PD_BSON_ITERATOR]; a_obj: CE_POINTER [PD_BSON])
		require
			not a_it.is_void
			not a_obj.is_void
		local
			l_result_len: INTEGER_32
			l_result_string: CE_POINTER [INTEGER_8]
			l_len: INTEGER_32
			l_tmp_1: INTEGER_32
		do
			l_result_len := (bson_iterator_string_len (a_it))
			l_result_string := (a_it.item.string)
			if l_result_len < 128 then
				l_tmp_1 := l_result_len
			else
				l_tmp_1 := 128
			end
			l_len := l_tmp_1
			memcpy (create {CE_VOID_POINTER}.make_cast (lasterrstr), create {CE_VOID_POINTER}.make_cast (l_result_string), l_len.to_natural_32).do_nothing
			if (a_it.item.bson_find (a_obj, ce_cstring ("code"))) /= {NATURAL_32} 10 then
				Current.lasterrcode := a_it.item.int
			end
		end

	init
		do
			memset (create {CE_VOID_POINTER}.make_shared (c_pointer), 0, (create {PD_MONGO}.make).structure_size.to_natural_32).do_nothing
			Current.max_bson_size := 4_194_304
		end

	connect (a_host: CE_POINTER [INTEGER_8]; a_port: INTEGER_32): INTEGER_32
		require
			not a_host.is_void
		local
			l_return: BOOLEAN
		do
			init
			Current.primary := create {CE_CLASS_POINTER [PD_MONGO_HOST_PORT]}.make_cast (((create {P_SRC_BSON_STATIC}).bson_malloc (((create {PD_MONGO_HOST_PORT}.make).structure_size.to_natural_32).to_integer_32)))
			strncpy (primary.item.host, a_host, (strlen (a_host)) + {NATURAL_32} 1).do_nothing
			primary.item.port := a_port
			primary.item.next := create {CE_CLASS_POINTER [PD_MONGO_HOST_PORT]}.make_shared (default_pointer)
			if env_socket_connect (address, a_host, a_port) /= 0 then
				Result := (-1)
				l_return := True
			end
			if not l_return then
				if (check_is_master ((create {CE_CLASS_POINTER [PD_MONGO]}.make_shared (c_pointer)))) /= 0 then
					Result := (-1)
				else
					Result := 0
				end
			end
		end

	replset_init (a_name: CE_POINTER [INTEGER_8])
		require
			not a_name.is_void
		do
			init
			Current.replset := create {CE_CLASS_POINTER [PD_MONGO_REPLSET]}.make_cast (((create {P_SRC_BSON_STATIC}).bson_malloc (((create {PD_MONGO_REPLSET}.make).structure_size.to_natural_32).to_integer_32)))
			replset.item.primary_connected := 0
			replset.item.seeds := create {CE_CLASS_POINTER [PD_MONGO_HOST_PORT]}.make_shared (default_pointer)
			replset.item.hosts := create {CE_CLASS_POINTER [PD_MONGO_HOST_PORT]}.make_shared (default_pointer)
			replset.item.name := create {CE_INTEGER_8_POINTER}.make_cast (((create {P_SRC_BSON_STATIC}).bson_malloc (((strlen (a_name)) + {NATURAL_32} 1).to_integer_32)))
			memcpy (create {CE_VOID_POINTER}.make_cast (replset.item.name), create {CE_VOID_POINTER}.make_cast (a_name), (strlen (a_name)) + {NATURAL_32} 1).do_nothing
			Current.primary := create {CE_CLASS_POINTER [PD_MONGO_HOST_PORT]}.make_cast (((create {P_SRC_BSON_STATIC}).bson_malloc (((create {PD_MONGO_HOST_PORT}.make).structure_size.to_natural_32).to_integer_32)))
			primary.item.host[0] := (('%/0/').code).to_integer_8
			primary.item.next := create {CE_CLASS_POINTER [PD_MONGO_HOST_PORT]}.make_shared (default_pointer)
		end

	replset_add_seed (a_host: CE_POINTER [INTEGER_8]; a_port: INTEGER_32)
		require
			not a_host.is_void
		do
			replset_add_node (create {CE_POINTER_POINTER [PD_MONGO_HOST_PORT]}.make_shared (replset.c_pointer + (create {PD_MONGO_REPLSET}.make).offset_of ("seeds")), a_host, a_port)
		end

	replset_check_seed
		local
			l_out: CE_ARRAY [PD_BSON]
			l_hosts: CE_ARRAY [PD_BSON]
			l_data_0: CE_POINTER [INTEGER_8]
			l_it: CE_ARRAY [PD_BSON_ITERATOR]
			l_it_sub: CE_ARRAY [PD_BSON_ITERATOR]
			l_host_string: CE_POINTER [INTEGER_8]
			l_host_port: CE_POINTER [PD_MONGO_HOST_PORT]
			l_break: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_BSON]} l_out.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_BSON]} l_hosts.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_BSON_ITERATOR]} l_it.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_BSON_ITERATOR]} l_it_sub.make (<<1>>)

			l_host_port := create {CE_CLASS_POINTER [PD_MONGO_HOST_PORT]}.make_shared (default_pointer)
			l_out.item.data := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
			l_hosts.item.data := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
			if mongo_simple_int_command ((create {CE_CLASS_POINTER [PD_MONGO]}.make_shared (c_pointer)), ce_cstring ("admin"), ce_cstring ("ismaster"), 1, l_out) = 0 then
				if (l_it.item.bson_find (l_out, ce_cstring ("hosts"))).to_boolean then
					l_data_0 := l_it.item.value
					l_it_sub.item.from_buffer (l_data_0)
					from
					until
						(l_break)
					loop
						l_break := False
						if not (l_it_sub.item.next).to_boolean then
							l_break := True
						end
						if not (l_break) then
							l_host_string := l_it_sub.item.string
							l_host_port := create {CE_CLASS_POINTER [PD_MONGO_HOST_PORT]}.make_cast (((create {P_SRC_BSON_STATIC}).bson_malloc (((create {PD_MONGO_HOST_PORT}.make).structure_size.to_natural_32).to_integer_32)))
							parse_host (l_host_string, l_host_port)
							if (not l_host_port.is_void) then
								replset_add_node (create {CE_POINTER_POINTER [PD_MONGO_HOST_PORT]}.make_shared (replset.c_pointer + (create {PD_MONGO_REPLSET}.make).offset_of ("hosts")), (l_host_port.item.host), l_host_port.item.port);
								(create {P_SRC_BSON_STATIC}).bson_free (create {CE_VOID_POINTER}.make_cast (l_host_port))
								l_host_port := create {CE_CLASS_POINTER [PD_MONGO_HOST_PORT]}.make_shared (default_pointer)
							end
						end
					end
					l_break := False
				end
			end
			l_out.item.destroy
			l_hosts.item.destroy
			env_close_socket (sock).do_nothing
			Current.sock := 0
			Current.connected := 0
		end

	replset_check_host: INTEGER_32
		local
			l_out: CE_ARRAY [PD_BSON]
			l_it: CE_ARRAY [PD_BSON_ITERATOR]
			l_ismaster: INTEGER_32
			l_set_name: CE_POINTER [INTEGER_8]
			l_max_bson_size: INTEGER_32
			l_return: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_BSON]} l_out.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_BSON_ITERATOR]} l_it.make (<<1>>)

			l_ismaster := 0
			l_max_bson_size := 4_194_304
			l_out.item.data := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
			if (mongo_simple_int_command ((create {CE_CLASS_POINTER [PD_MONGO]}.make_shared (c_pointer)), ce_cstring ("admin"), ce_cstring ("ismaster"), 1, l_out)) = 0 then
				if (l_it.item.bson_find (l_out, ce_cstring ("ismaster"))).to_boolean then
					l_ismaster := l_it.item.bool
				end
				if (l_it.item.bson_find (l_out, ce_cstring ("maxBsonObjectSize"))).to_boolean then
					l_max_bson_size := l_it.item.int
				end
				Current.max_bson_size := l_max_bson_size
				if (l_it.item.bson_find (l_out, ce_cstring ("setName"))).to_boolean then
					l_set_name := l_it.item.string
					if (strcmp (l_set_name, replset.item.name)) /= 0 then
						l_out.item.destroy
						Current.err := {PC_MONGO_ERROR_T}.Mongo_conn_bad_set_name
						Result := (-1)
						l_return := True
					end
				end
			end
			if not l_return then
				l_out.item.destroy
				if l_ismaster.to_boolean then
					replset.item.primary_connected := 1
				else
					env_close_socket (sock).do_nothing
				end
				Result := 0
			end
		end

	replset_connect: INTEGER_32
		local
			l_res: INTEGER_32
			l_node: CE_POINTER [PD_MONGO_HOST_PORT]
			l_return, l_break: BOOLEAN
		do
			l_res := 0
			Current.sock := 0
			Current.connected := 0
			l_node := replset.item.seeds
			from
			until
				not (not (l_break) and then (not l_node.is_void))
			loop
				l_break := False
				l_res := env_socket_connect (address, create {CE_INTEGER_8_POINTER}.make_cast ((create {CE_ARRAY_POINTER [INTEGER_8]}.make_shared (l_node.c_pointer + (create {PD_MONGO_HOST_PORT}.make).offset_of ("host")))), l_node.item.port)
				if l_res = 0 then
					replset_check_seed
					if (not (replset.item.hosts).is_void) then
						l_break := True
					end
				end
				if not (l_break) then
					l_node := l_node.item.next
				end
			end
			l_break := False
			if (replset.item.hosts).is_void then
				Current.err := {PC_MONGO_ERROR_T}.Mongo_conn_no_primary
				Result := (-1)
				l_return := True
			else
				l_node := replset.item.hosts
				from
				until
					not (not (l_return) and then (not l_node.is_void))
				loop
					l_res := env_socket_connect (address, create {CE_INTEGER_8_POINTER}.make_cast ((create {CE_ARRAY_POINTER [INTEGER_8]}.make_shared (l_node.c_pointer + (create {PD_MONGO_HOST_PORT}.make).offset_of ("host")))), l_node.item.port)
					if l_res = 0 then
						if (replset_check_host) /= 0 then
							Result := (-1)
							l_return := True
						elseif (replset.item.primary_connected).to_boolean then
							strncpy (primary.item.host, (l_node.item.host), (strlen ((l_node.item.host))) + {NATURAL_32} 1).do_nothing
							primary.item.port := l_node.item.port
							Result := 0
							l_return := True
						else
							env_close_socket (sock).do_nothing
							Current.sock := 0
							Current.connected := 0
						end
					end
					if not l_return then
						l_node := l_node.item.next
					end
				end
			end
			if not l_return then
				Current.err := {PC_MONGO_ERROR_T}.Mongo_conn_no_primary
				Result := (-1)
			end
		end

	set_op_timeout (a_millis: INTEGER_32): INTEGER_32
		do
			Current.op_timeout_ms := a_millis
			if sock.to_boolean then
				if connected.to_boolean then
					env_set_socket_op_timeout (address, a_millis).do_nothing
				end
			end
			Result := 0
		end

	reconnect: INTEGER_32
		local
			l_res: INTEGER_32
		do
			disconnect
			if (not replset.is_void) then
				replset.item.primary_connected := 0
				replset_free_list (create {CE_POINTER_POINTER [PD_MONGO_HOST_PORT]}.make_shared (replset.c_pointer + (create {PD_MONGO_REPLSET}.make).offset_of ("hosts")))
				replset.item.hosts := create {CE_CLASS_POINTER [PD_MONGO_HOST_PORT]}.make_shared (default_pointer)
				l_res := replset_connect
				Result := l_res
			else
				Result := env_socket_connect (address, (primary.item.host), primary.item.port)
			end
		end

	check_connection: INTEGER_32
		local
			l_return: BOOLEAN
		do
			if not connected.to_boolean then
				Result := (-1)
				l_return := True
			end
			if not l_return then
				if (mongo_simple_int_command ((create {CE_CLASS_POINTER [PD_MONGO]}.make_shared (c_pointer)), ce_cstring ("admin"), ce_cstring ("ping"), 1, create {CE_CLASS_POINTER [PD_BSON]}.make_shared (default_pointer))) = 0 then
					Result := 0
				else
					Result := (-1)
				end
			end
		end

	disconnect
		local
			l_return: BOOLEAN
		do
			if not connected.to_boolean then
				l_return := True
			end
			if not l_return then
				if (not replset.is_void) then
					replset.item.primary_connected := 0
					replset_free_list (create {CE_POINTER_POINTER [PD_MONGO_HOST_PORT]}.make_shared (replset.c_pointer + (create {PD_MONGO_REPLSET}.make).offset_of ("hosts")))
					replset.item.hosts := create {CE_CLASS_POINTER [PD_MONGO_HOST_PORT]}.make_shared (default_pointer)
				end
				env_close_socket (sock).do_nothing
				Current.sock := 0
				Current.connected := 0
			end
		end

	destroy
		do
			disconnect
			if (not replset.is_void) then
				replset_free_list (create {CE_POINTER_POINTER [PD_MONGO_HOST_PORT]}.make_shared (replset.c_pointer + (create {PD_MONGO_REPLSET}.make).offset_of ("seeds")))
				replset_free_list (create {CE_POINTER_POINTER [PD_MONGO_HOST_PORT]}.make_shared (replset.c_pointer + (create {PD_MONGO_REPLSET}.make).offset_of ("hosts")));
				(create {P_SRC_BSON_STATIC}).bson_free (create {CE_VOID_POINTER}.make_cast (replset.item.name));
				(create {P_SRC_BSON_STATIC}).bson_free (create {CE_VOID_POINTER}.make_cast (replset))
				Current.replset := create {CE_CLASS_POINTER [PD_MONGO_REPLSET]}.make_shared (default_pointer)
			end
			(create {P_SRC_BSON_STATIC}).bson_free (create {CE_VOID_POINTER}.make_cast (primary));
			clear_errors
		end

	bson_valid (a_bson_0: CE_POINTER [PD_BSON]; a_write: INTEGER_32): INTEGER_32
		local
			l_size: INTEGER_32
			l_return: BOOLEAN
		do
			l_size := (create {P_SRC_BSON_STATIC}).bson_size (a_bson_0)
			if l_size > max_bson_size then
				Current.err := {PC_MONGO_ERROR_T}.Mongo_bson_too_large
				Result := (-1)
				l_return := True
			end
			if not l_return and then (not (a_bson_0.item.finished).to_boolean) then
				Current.err := {PC_MONGO_ERROR_T}.Mongo_bson_not_finished
				Result := (-1)
				l_return := True
			end
			if not l_return and then (((a_bson_0.item.err).bit_and (2)).to_boolean) then
				Current.err := {PC_MONGO_ERROR_T}.Mongo_bson_invalid
				Result := (-1)
				l_return := True
			end
			if not l_return and then (a_write.to_boolean) then
				if ((a_bson_0.item.err).bit_and (4)).to_boolean then
					Current.err := {PC_MONGO_ERROR_T}.Mongo_bson_invalid
					Result := (-1)
					l_return := True
				elseif ((a_bson_0.item.err).bit_and (8)).to_boolean then
					Current.err := {PC_MONGO_ERROR_T}.Mongo_bson_invalid
					Result := (-1)
					l_return := True
				end
			end
			if not l_return then
				Current.err := {PC_MONGO_ERROR_T}.Mongo_conn_success
				Result := 0
			end
		end

	update (a_ns: CE_POINTER [INTEGER_8]; a_cond, a_op: CE_POINTER [PD_BSON]; a_flags: INTEGER_32; a_custom_write_concern: CE_POINTER [PD_MONGO_WRITE_CONCERN]): INTEGER_32
		local
			l_flags: CE_ARRAY [INTEGER_32]
			l_data_0: CE_POINTER [INTEGER_8]
			l_mm: CE_POINTER [PD_MONGO_MESSAGE]
			l_write_concern: CE_ARRAY [CE_POINTER [PD_MONGO_WRITE_CONCERN]]
			l_tmp_1: NATURAL_32
			l_tmp_2: INTEGER_32
			l_return: BOOLEAN
		do
			create {CE_INTEGER_32_ARRAY} l_flags.make (<<1>>)
			create {CE_POINTER_ARRAY [PD_MONGO_WRITE_CONCERN]} l_write_concern.make (<<1>>)

			l_flags.item := a_flags
			l_write_concern.item := create {CE_CLASS_POINTER [PD_MONGO_WRITE_CONCERN]}.make_shared (default_pointer)
			if (bson_valid (a_op, 0)) /= 0 then
				Result := (-1)
				l_return := True
			end
			if not l_return then
				if (mongo_choose_write_concern ((create {CE_CLASS_POINTER [PD_MONGO]}.make_shared (c_pointer)), a_custom_write_concern, l_write_concern)) = -1 then
					Result := (-1)
					l_return := True
				end
			end
			if not l_return then
				l_tmp_1 := strlen (a_ns)
				l_tmp_2 := (create {P_SRC_BSON_STATIC}).bson_size (a_cond)
				l_mm := mongo_message_create (((((({NATURAL_32} 20 + l_tmp_1) + {NATURAL_32} 1) + {NATURAL_32} 4) + l_tmp_2.to_natural_32) + ((create {P_SRC_BSON_STATIC}).bson_size (a_op)).to_natural_32).to_integer_32, 0, 0, 2_001)
				l_data_0 := create {CE_INTEGER_8_POINTER}.make_shared (l_mm.c_pointer + (create {PD_MONGO_MESSAGE}.make).offset_of ("data"))
				l_data_0 := mongo_data_append32 (l_data_0, create {CE_VOID_POINTER}.make_cast ((zero.item)))
				l_data_0 := mongo_data_append (l_data_0, create {CE_VOID_POINTER}.make_cast (a_ns), ((strlen (a_ns)) + {NATURAL_32} 1).to_integer_32)
				l_data_0 := mongo_data_append32 (l_data_0, create {CE_VOID_POINTER}.make_cast (l_flags))
				l_data_0 := mongo_data_append (l_data_0, create {CE_VOID_POINTER}.make_cast (a_cond.item.data), ((create {P_SRC_BSON_STATIC}).bson_size (a_cond)))
				l_data_0 := mongo_data_append (l_data_0, create {CE_VOID_POINTER}.make_cast (a_op.item.data), ((create {P_SRC_BSON_STATIC}).bson_size (a_op)))
				if (not (l_write_concern.item).is_void) then
					if (mongo_message_send ((create {CE_CLASS_POINTER [PD_MONGO]}.make_shared (c_pointer)), l_mm)) = -1 then
						Result := (-1)
						l_return := True
					end
					if not l_return then
						Result := (mongo_check_last_error ((create {CE_CLASS_POINTER [PD_MONGO]}.make_shared (c_pointer)), a_ns, l_write_concern.item))
					end
				else
					Result := (mongo_message_send ((create {CE_CLASS_POINTER [PD_MONGO]}.make_shared (c_pointer)), l_mm))
				end
			end
		end

	set_write_concern (a_write_concern: CE_POINTER [PD_MONGO_WRITE_CONCERN])
		do
			Current.write_concern := a_write_concern
		end

	cmd_get_error_helper (a_db: CE_POINTER [INTEGER_8]; a_realout: CE_POINTER [PD_BSON]; a_cmdtype: CE_POINTER [INTEGER_8]): INTEGER_32
		require
			not a_db.is_void
			not a_cmdtype.is_void
		local
			l_out: CE_ARRAY [PD_BSON]
			l_haserror: INTEGER_32
			l_it: CE_ARRAY [PD_BSON_ITERATOR]
		do
			create {CE_CLASS_ARRAY [PD_BSON]} l_out.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_BSON_ITERATOR]} l_it.make (<<1>>)

			l_out.item.data := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
			l_out.item.cur := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
			l_out.item.data_size := 0
			l_out.item.finished := 0
			l_out.item.stack[0] := 0
			l_out.item.stack[1] := 0
			l_out.item.stack[2] := 0
			l_out.item.stack[3] := 0
			l_out.item.stack[4] := 0
			l_out.item.stack[5] := 0
			l_out.item.stack[6] := 0
			l_out.item.stack[7] := 0
			l_out.item.stack[8] := 0
			l_out.item.stack[9] := 0
			l_out.item.stack[10] := 0
			l_out.item.stack[11] := 0
			l_out.item.stack[12] := 0
			l_out.item.stack[13] := 0
			l_out.item.stack[14] := 0
			l_out.item.stack[15] := 0
			l_out.item.stack[16] := 0
			l_out.item.stack[17] := 0
			l_out.item.stack[18] := 0
			l_out.item.stack[19] := 0
			l_out.item.stack[20] := 0
			l_out.item.stack[21] := 0
			l_out.item.stack[22] := 0
			l_out.item.stack[23] := 0
			l_out.item.stack[24] := 0
			l_out.item.stack[25] := 0
			l_out.item.stack[26] := 0
			l_out.item.stack[27] := 0
			l_out.item.stack[28] := 0
			l_out.item.stack[29] := 0
			l_out.item.stack[30] := 0
			l_out.item.stack[31] := 0
			l_out.item.stack_pos := 0
			l_out.item.err := 0
			l_out.item.errstr := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
			l_haserror := 0;
			clear_errors
			if (mongo_simple_int_command ((create {CE_CLASS_POINTER [PD_MONGO]}.make_shared (c_pointer)), a_db, a_cmdtype, 1, l_out)) = 0 then
				l_haserror := ((l_it.item.bson_find (l_out, ce_cstring ("err"))) /= {NATURAL_32} 10).to_integer
				if l_haserror.to_boolean then
					set_last_error (l_it, l_out)
				end
			end
			if (not a_realout.is_void) then
				a_realout.item := (l_out.item).twin
			else
				l_out.item.destroy
			end
			if l_haserror.to_boolean then
				Result := (-1)
			else
				Result := 0
			end
		end

	cmd_get_prev_error (a_db: CE_POINTER [INTEGER_8]; a_out: CE_POINTER [PD_BSON]): INTEGER_32
		require
			not a_db.is_void
			not a_out.is_void
		do
			Result := (cmd_get_error_helper (a_db, a_out, ce_cstring ("getpreverror")))
		end

	cmd_get_last_error (a_db: CE_POINTER [INTEGER_8]; a_out: CE_POINTER [PD_BSON]): INTEGER_32
		require
			not a_db.is_void
			not a_out.is_void
		do
			Result := (cmd_get_error_helper (a_db, a_out, ce_cstring ("getlasterror")))
		end

	cmd_add_user (a_db, a_user, a_pass: CE_POINTER [INTEGER_8]): INTEGER_32
		require
			not a_db.is_void
			not a_user.is_void
			not a_pass.is_void
		local
			l_user_obj: CE_ARRAY [PD_BSON]
			l_pass_obj: CE_ARRAY [PD_BSON]
			l_hex_digest: CE_ARRAY [INTEGER_8]
			l_ns: CE_POINTER [INTEGER_8]
			l_tmp: NATURAL_32
			l_res: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_BSON]} l_user_obj.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_BSON]} l_pass_obj.make (<<1>>)
			create {CE_INTEGER_8_ARRAY} l_hex_digest.make (<<33>>)

			l_tmp := strlen (a_db)
			l_ns := create {CE_INTEGER_8_POINTER}.make_cast (((create {P_SRC_BSON_STATIC}).bson_malloc (((l_tmp + (strlen (ce_cstring (".system.users")))) + {NATURAL_32} 1).to_integer_32)))
			strcpy (l_ns, a_db).do_nothing
			strcpy (l_ns + (strlen (a_db)).to_integer_32, ce_cstring (".system.users")).do_nothing;
			mongo_pass_digest (a_user, a_pass, l_hex_digest)
			l_user_obj.item.init;
			l_user_obj.item.append_string (ce_cstring ("user"), a_user).do_nothing
			l_user_obj.item.finish.do_nothing
			l_pass_obj.item.init
			l_pass_obj.item.append_start_object (ce_cstring ("$set")).do_nothing;
			l_pass_obj.item.append_string (ce_cstring ("pwd"), l_hex_digest).do_nothing
			l_pass_obj.item.append_finish_object.do_nothing
			l_pass_obj.item.finish.do_nothing
			l_res := update (l_ns, l_user_obj, l_pass_obj, 1, create {CE_CLASS_POINTER [PD_MONGO_WRITE_CONCERN]}.make_shared (default_pointer));
			(create {P_SRC_BSON_STATIC}).bson_free (create {CE_VOID_POINTER}.make_cast (l_ns));
			l_user_obj.item.destroy
			l_pass_obj.item.destroy
			Result := l_res
		end

	create_index (a_ns: CE_POINTER [INTEGER_8]; a_key: CE_POINTER [PD_BSON]; a_options: INTEGER_32; a_out: CE_POINTER [PD_BSON]): INTEGER_32
		require
			not a_ns.is_void
			not a_key.is_void
		local
			l_b: CE_ARRAY [PD_BSON]
			l_it: CE_ARRAY [PD_BSON_ITERATOR]
			l_name: CE_ARRAY [INTEGER_8]
			l_tmp: NATURAL_32
			l_i: INTEGER_32
			l_idxns: CE_ARRAY [INTEGER_8]
			l_break: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_BSON]} l_b.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_BSON_ITERATOR]} l_it.make (<<1>>)
			create {CE_INTEGER_8_ARRAY} l_name.make (<<255>>)
			create {CE_INTEGER_8_ARRAY} l_idxns.make (<<1_024>>)

			l_name[0] := (('_').code).to_integer_8
			l_tmp := {NATURAL_32} 1
			from
			until
				(l_tmp >= {NATURAL_32} 255)
			loop
				l_name[l_tmp.to_integer_32] := (0).to_integer_8
				l_tmp := l_tmp + 1
			end
			l_i := 1
			l_it.item.init (a_key)
			from
			until
				(l_break)
			loop
				l_break := False
				if l_i < 255 then
					if not (l_it.item.next).to_boolean then
						l_break := True
					end
				else
					l_break := True
				end
				if not (l_break) then
					strncpy (l_name + l_i, (l_it.item.key), (255 - l_i).to_natural_32).do_nothing
					l_i := (l_i.to_natural_32 + (strlen ((l_it.item.key)))).to_integer_32
				end
			end
			l_break := False
			l_name[254] := (('%/0/').code).to_integer_8
			l_b.item.init
			l_b.item.append_bson (ce_cstring ("key"), a_key).do_nothing;
			l_b.item.append_string (ce_cstring ("ns"), a_ns).do_nothing;
			l_b.item.append_string (ce_cstring ("name"), l_name).do_nothing
			if ((a_options).bit_and (1)).to_boolean then
				l_b.item.append_bool (ce_cstring ("unique"), 1).do_nothing
			end
			if ((a_options).bit_and (4)).to_boolean then
				l_b.item.append_bool (ce_cstring ("dropDups"), 1).do_nothing
			end
			if ((a_options).bit_and (8)).to_boolean then
				l_b.item.append_bool (ce_cstring ("background"), 1).do_nothing
			end
			if ((a_options).bit_and (16)).to_boolean then
				l_b.item.append_bool (ce_cstring ("sparse"), 1).do_nothing
			end
			l_b.item.finish.do_nothing
			strncpy (l_idxns, a_ns, {NATURAL_32} 1_008).do_nothing
			strcpy ((strchr (l_idxns, ('.').code)), ce_cstring (".system.indexes")).do_nothing;
			insert (l_idxns, l_b, create {CE_CLASS_POINTER [PD_MONGO_WRITE_CONCERN]}.make_shared (default_pointer)).do_nothing
			l_b.item.destroy;
			(strchr (l_idxns, ('.').code))[0] := (('%/0/').code).to_integer_8
			Result := (cmd_get_last_error (l_idxns, a_out))
		end

	create_simple_index (a_ns, a_field: CE_POINTER [INTEGER_8]; a_options: INTEGER_32; a_out: CE_POINTER [PD_BSON]): INTEGER_32
		require
			not a_ns.is_void
			not a_field.is_void
		local
			l_b: CE_ARRAY [PD_BSON]
			l_success: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_BSON]} l_b.make (<<1>>)

			l_b.item.init
			l_b.item.append_int (a_field, 1).do_nothing
			l_b.item.finish.do_nothing
			l_success := create_index (a_ns, l_b, a_options, a_out)
			l_b.item.destroy
			Result := l_success
		end

	insert (a_ns: CE_POINTER [INTEGER_8]; a_bson_0: CE_POINTER [PD_BSON]; a_custom_write_concern: CE_POINTER [PD_MONGO_WRITE_CONCERN]): INTEGER_32
		require
			not a_ns.is_void
		local
			l_data_0: CE_POINTER [INTEGER_8]
			l_mm: CE_POINTER [PD_MONGO_MESSAGE]
			l_write_concern: CE_ARRAY [CE_POINTER [PD_MONGO_WRITE_CONCERN]]
			l_tmp_2: NATURAL_32
			l_return: BOOLEAN
		do
			create {CE_POINTER_ARRAY [PD_MONGO_WRITE_CONCERN]} l_write_concern.make (<<1>>)

			l_write_concern.item := create {CE_CLASS_POINTER [PD_MONGO_WRITE_CONCERN]}.make_shared (default_pointer)
			if mongo_validate_ns (address, a_ns) /= 0 then
				Result := (-1)
				l_return := True
			end
			if not l_return then
				if bson_valid (a_bson_0, 1) /= 0 then
					Result := (-1)
					l_return := True
				end
			end
			if not l_return then
				if (mongo_choose_write_concern (address, a_custom_write_concern, l_write_concern)) = -1 then
					Result := (-1)
					l_return := True
				end
			end
			if not l_return then
				l_tmp_2 := strlen (a_ns)
				l_mm := mongo_message_create (((({NATURAL_32} 20 + l_tmp_2) + {NATURAL_32} 1) + ((create {P_SRC_BSON_STATIC}).bson_size (a_bson_0)).to_natural_32).to_integer_32, 0, 0, 2_002)
				l_data_0 := create {CE_INTEGER_8_POINTER}.make_shared (l_mm.c_pointer + (create {PD_MONGO_MESSAGE}.make).offset_of ("data"))
				l_data_0 := mongo_data_append32 (l_data_0, create {CE_VOID_POINTER}.make_cast (zero.item))
				l_data_0 := mongo_data_append (l_data_0, create {CE_VOID_POINTER}.make_cast (a_ns), ((strlen (a_ns)) + {NATURAL_32} 1).to_integer_32)
				l_data_0 := mongo_data_append (l_data_0, create {CE_VOID_POINTER}.make_cast (a_bson_0.item.data), ((create {P_SRC_BSON_STATIC}).bson_size (a_bson_0)))
				if (not (l_write_concern.item).is_void) then
					if mongo_message_send (address, l_mm) = -1 then
						Result := (-1)
						l_return := True
					end
					if not l_return then
						Result := (mongo_check_last_error (address, a_ns, l_write_concern.item))
					end
				else
					Result := mongo_message_send (address, l_mm)
				end
			end
		end

	remove (a_ns: CE_POINTER [INTEGER_8]; a_cond: CE_POINTER [PD_BSON]; a_custom_write_concern: CE_POINTER [PD_MONGO_WRITE_CONCERN]): INTEGER_32
		local
			l_data_0: CE_POINTER [INTEGER_8]
			l_mm: CE_POINTER [PD_MONGO_MESSAGE]
			l_write_concern: CE_ARRAY [CE_POINTER [PD_MONGO_WRITE_CONCERN]]
			l_tmp_1: NATURAL_32
			l_return: BOOLEAN
		do
			create {CE_POINTER_ARRAY [PD_MONGO_WRITE_CONCERN]} l_write_concern.make (<<1>>)

			l_write_concern.item := create {CE_CLASS_POINTER [PD_MONGO_WRITE_CONCERN]}.make_shared (default_pointer)
			if bson_valid (a_cond, 0) /= 0 then
				Result := (-1)
				l_return := True
			end
			if not l_return then
				if mongo_choose_write_concern (address, a_custom_write_concern, l_write_concern) = -1 then
					Result := (-1)
					l_return := True
				end
			end
			if not l_return then
				l_tmp_1 := strlen (a_ns)
				l_mm := mongo_message_create ((((({NATURAL_32} 20 + l_tmp_1) + {NATURAL_32} 1) + {NATURAL_32} 4) + ((create {P_SRC_BSON_STATIC}).bson_size (a_cond)).to_natural_32).to_integer_32, 0, 0, 2_006)
				l_data_0 := create {CE_INTEGER_8_POINTER}.make_shared (l_mm.c_pointer + (create {PD_MONGO_MESSAGE}.make).offset_of ("data"))
				l_data_0 := mongo_data_append32 (l_data_0, create {CE_VOID_POINTER}.make_cast ((zero.item)))
				l_data_0 := mongo_data_append (l_data_0, create {CE_VOID_POINTER}.make_cast (a_ns), ((strlen (a_ns)) + {NATURAL_32} 1).to_integer_32)
				l_data_0 := mongo_data_append32 (l_data_0, create {CE_VOID_POINTER}.make_cast ((zero.item)))
				l_data_0 := mongo_data_append (l_data_0, create {CE_VOID_POINTER}.make_cast (a_cond.item.data), ((create {P_SRC_BSON_STATIC}).bson_size (a_cond)))
				if (not (l_write_concern.item).is_void) then
					if mongo_message_send (address, l_mm) = -1 then
						Result := (-1)
						l_return := True
					end
					if not l_return then
						Result := mongo_check_last_error (address, a_ns, l_write_concern.item)
					end
				else
					Result := mongo_message_send (address, l_mm)
				end
			end
		end

	init_sockets
		do
			(create {P_SRC_ENV_STATIC}).env_sock_init.do_nothing
		end

feature {PD_MONGO} -- private routines

	replset_free_list (a_list: CE_POINTER [CE_POINTER [PD_MONGO_HOST_PORT]])
		require
			not a_list.is_void
		local
			l_node: CE_POINTER [PD_MONGO_HOST_PORT]
			l_prev: CE_POINTER [PD_MONGO_HOST_PORT]
		do
			l_node := a_list.item
			from
			until
				l_node.is_void
			loop
				l_prev := l_node
				l_node := l_node.item.next;
				(create {P_SRC_BSON_STATIC}).bson_free (create {CE_VOID_POINTER}.make_cast (l_prev))
			end
			a_list.item := create {CE_CLASS_POINTER [PD_MONGO_HOST_PORT]}.make_shared (default_pointer)
		end

	replset_add_node (a_list: CE_POINTER [CE_POINTER [PD_MONGO_HOST_PORT]]; a_host: CE_POINTER [INTEGER_8]; a_port: INTEGER_32)
		require
			not a_list.is_void
			not a_host.is_void
		local
			l_host_port: CE_POINTER [PD_MONGO_HOST_PORT]
			l_p: CE_POINTER [PD_MONGO_HOST_PORT]
		do
			l_host_port := create {CE_CLASS_POINTER [PD_MONGO_HOST_PORT]}.make_cast (((create {P_SRC_BSON_STATIC}).bson_malloc (((create {PD_MONGO_HOST_PORT}.make).structure_size.to_natural_32).to_integer_32)))
			l_host_port.item.port := a_port
			l_host_port.item.next := create {CE_CLASS_POINTER [PD_MONGO_HOST_PORT]}.make_shared (default_pointer)
			strncpy (l_host_port.item.host, a_host, (strlen (a_host)) + {NATURAL_32} 1).do_nothing
			if (a_list.item).is_void then
				a_list.item := l_host_port
			else
				l_p := a_list.item
				from
				until
					(l_p.item.next).is_void
				loop
					l_p := l_p.item.next
				end
				l_p.item.next := l_host_port
			end
		end

	bson_iterator_string_len (a_i: CE_POINTER [PD_BSON_ITERATOR]): INTEGER_32
		require
			not a_i.is_void
		do
			Result := (a_i.item.int_raw)
		end

	check_is_master (a_conn: CE_POINTER [PD_MONGO]): INTEGER_32
		local
			l_out: CE_ARRAY [PD_BSON]
			l_it: CE_ARRAY [PD_BSON_ITERATOR]
			l_ismaster: INTEGER_32
			l_max_bson_size: INTEGER_32
			l_return: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_BSON]} l_out.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_BSON_ITERATOR]} l_it.make (<<1>>)

			l_ismaster := 0
			l_max_bson_size := 4_194_304
			l_out.item.data := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
			if (mongo_simple_int_command (a_conn, ce_cstring ("admin"), ce_cstring ("ismaster"), 1, l_out)) = 0 then
				if (l_it.item.bson_find (l_out, ce_cstring ("ismaster"))).to_boolean then
					l_ismaster := l_it.item.bool
				end
				if (l_it.item.bson_find (l_out, ce_cstring ("maxBsonObjectSize"))).to_boolean then
					l_max_bson_size := l_it.item.int
				end
				a_conn.item.max_bson_size := l_max_bson_size
			else
				Result := (-1)
				l_return := True
			end
			if not l_return then
				l_out.item.destroy
				if l_ismaster.to_boolean then
					Result := 0
				else
					a_conn.item.err := {PC_MONGO_ERROR_T}.Mongo_conn_not_master
					Result := (-1)
				end
			end
		end

	parse_host (a_host_string: CE_POINTER [INTEGER_8]; a_host_port: CE_POINTER [PD_MONGO_HOST_PORT])
		require
			not a_host_string.is_void
			not a_host_port.is_void
		local
			l_len: INTEGER_32
			l_idx: INTEGER_32
			l_split: INTEGER_32
		do
			l_idx := 0
			l_split := l_idx
			l_len := l_split
			from
			until
				((a_host_string[l_len]).to_integer_32 = 0)
			loop
				if (a_host_string[l_len]).to_integer_32 = 58 then
					l_split := l_len
				end
				l_len := l_len + 1
			end
			if l_split.to_boolean then
				l_idx := l_split
			else
				l_idx := l_len
			end
			memcpy (create {CE_VOID_POINTER}.make_cast ((a_host_port.item.host)), create {CE_VOID_POINTER}.make_cast (a_host_string), l_idx.to_natural_32).do_nothing
			memcpy (create {CE_VOID_POINTER}.make_cast ((a_host_port.item.host + l_idx)), create {CE_VOID_POINTER}.make_cast (ce_cstring ("%/0/")), (1).to_natural_32).do_nothing
			if l_split.to_boolean then
				a_host_port.item.port := atoi ((a_host_string + l_idx) + 1)
			else
				a_host_port.item.port := 27_017
			end
		end

feature {ANY}

	structure_size: INTEGER_32
		external
			"C inline use %"libmongo.h%""
		alias
			"return sizeof(struct mongo);"
		end

	structure_alignment: INTEGER_32
		external
			"C inline use %"libmongo.h%""
		alias
			"return __alignof__(struct mongo);"
		end

	offset_of (a_field_name: STRING_8): INTEGER_32
		local
			l_c_str: C_STRING
		do
			create l_c_str.make (a_field_name)
			Result := c__offset_of (l_c_str.item)
		end

feature {ANY}

	copy (a_other: like Current)
		do
			make
			internal_c_pointer.memory_copy (a_other.c_pointer, structure_size)
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result := internal_c_pointer.memory_compare (a_other.c_pointer, structure_size)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		do
			-- dummy for CE_CLASS invariant
			create Result.make_struct (<<>>)
			Result.alignment := structure_alignment
		end

	c__primary (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"libmongo.h%""
		alias
			"return (EIF_POINTER)((struct mongo *)$a_c_pointer)->primary;"
		end

	c__replset (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"libmongo.h%""
		alias
			"return (EIF_POINTER)((struct mongo *)$a_c_pointer)->replset;"
		end

	c__sock (a_c_pointer: POINTER): INTEGER_32
		external
			"C inline use %"libmongo.h%""
		alias
			"return ((struct mongo *)$a_c_pointer)->sock;"
		end

	c__flags (a_c_pointer: POINTER): INTEGER_32
		external
			"C inline use %"libmongo.h%""
		alias
			"return ((struct mongo *)$a_c_pointer)->flags;"
		end

	c__conn_timeout_ms (a_c_pointer: POINTER): INTEGER_32
		external
			"C inline use %"libmongo.h%""
		alias
			"return ((struct mongo *)$a_c_pointer)->conn_timeout_ms;"
		end

	c__op_timeout_ms (a_c_pointer: POINTER): INTEGER_32
		external
			"C inline use %"libmongo.h%""
		alias
			"return ((struct mongo *)$a_c_pointer)->op_timeout_ms;"
		end

	c__max_bson_size (a_c_pointer: POINTER): INTEGER_32
		external
			"C inline use %"libmongo.h%""
		alias
			"return ((struct mongo *)$a_c_pointer)->max_bson_size;"
		end

	c__connected (a_c_pointer: POINTER): INTEGER_32
		external
			"C inline use %"libmongo.h%""
		alias
			"return ((struct mongo *)$a_c_pointer)->connected;"
		end

	c__write_concern (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"libmongo.h%""
		alias
			"return (EIF_POINTER)((struct mongo *)$a_c_pointer)->write_concern;"
		end

	c__err (a_c_pointer: POINTER): NATURAL_32
		external
			"C inline use %"libmongo.h%""
		alias
			"return ((struct mongo *)$a_c_pointer)->err;"
		end

	c__errcode (a_c_pointer: POINTER): INTEGER_32
		external
			"C inline use %"libmongo.h%""
		alias
			"return ((struct mongo *)$a_c_pointer)->errcode;"
		end

	c__errstr (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"libmongo.h%""
		alias
			"return (EIF_POINTER)((struct mongo *)$a_c_pointer)->errstr;"
		end

	c__lasterrcode (a_c_pointer: POINTER): INTEGER_32
		external
			"C inline use %"libmongo.h%""
		alias
			"return ((struct mongo *)$a_c_pointer)->lasterrcode;"
		end

	c__lasterrstr (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"libmongo.h%""
		alias
			"return (EIF_POINTER)((struct mongo *)$a_c_pointer)->lasterrstr;"
		end

	c__set_primary (a_c_pointer: POINTER; a_primary: POINTER)
		external
			"C inline use %"libmongo.h%""
		alias
			"((struct mongo *)$a_c_pointer)->primary = $a_primary;"
		end

	c__set_replset (a_c_pointer: POINTER; a_replset: POINTER)
		external
			"C inline use %"libmongo.h%""
		alias
			"((struct mongo *)$a_c_pointer)->replset = $a_replset;"
		end

	c__set_sock (a_c_pointer: POINTER; a_sock: INTEGER_32)
		external
			"C inline use %"libmongo.h%""
		alias
			"((struct mongo *)$a_c_pointer)->sock = $a_sock;"
		end

	c__set_flags (a_c_pointer: POINTER; a_flags: INTEGER_32)
		external
			"C inline use %"libmongo.h%""
		alias
			"((struct mongo *)$a_c_pointer)->flags = $a_flags;"
		end

	c__set_conn_timeout_ms (a_c_pointer: POINTER; a_conn_timeout_ms: INTEGER_32)
		external
			"C inline use %"libmongo.h%""
		alias
			"((struct mongo *)$a_c_pointer)->conn_timeout_ms = $a_conn_timeout_ms;"
		end

	c__set_op_timeout_ms (a_c_pointer: POINTER; a_op_timeout_ms: INTEGER_32)
		external
			"C inline use %"libmongo.h%""
		alias
			"((struct mongo *)$a_c_pointer)->op_timeout_ms = $a_op_timeout_ms;"
		end

	c__set_max_bson_size (a_c_pointer: POINTER; a_max_bson_size: INTEGER_32)
		external
			"C inline use %"libmongo.h%""
		alias
			"((struct mongo *)$a_c_pointer)->max_bson_size = $a_max_bson_size;"
		end

	c__set_connected (a_c_pointer: POINTER; a_connected: INTEGER_32)
		external
			"C inline use %"libmongo.h%""
		alias
			"((struct mongo *)$a_c_pointer)->connected = $a_connected;"
		end

	c__set_write_concern (a_c_pointer: POINTER; a_write_concern: POINTER)
		external
			"C inline use %"libmongo.h%""
		alias
			"((struct mongo *)$a_c_pointer)->write_concern = $a_write_concern;"
		end

	c__set_err (a_c_pointer: POINTER; a_err: NATURAL_32)
		external
			"C inline use %"libmongo.h%""
		alias
			"((struct mongo *)$a_c_pointer)->err = $a_err;"
		end

	c__set_errcode (a_c_pointer: POINTER; a_errcode: INTEGER_32)
		external
			"C inline use %"libmongo.h%""
		alias
			"((struct mongo *)$a_c_pointer)->errcode = $a_errcode;"
		end

	c__set_lasterrcode (a_c_pointer: POINTER; a_lasterrcode: INTEGER_32)
		external
			"C inline use %"libmongo.h%""
		alias
			"((struct mongo *)$a_c_pointer)->lasterrcode = $a_lasterrcode;"
		end

	c__offset_of (a_field_name: POINTER): INTEGER_32
		external
			"C inline use %"libmongo.h%", <string.h>, <stddef.h>, <stdio.h>"
		alias
			"[
				if(strcmp($a_field_name, "primary") == 0) return offsetof(struct mongo, primary);
				if(strcmp($a_field_name, "replset") == 0) return offsetof(struct mongo, replset);
				if(strcmp($a_field_name, "sock") == 0) return offsetof(struct mongo, sock);
				if(strcmp($a_field_name, "flags") == 0) return offsetof(struct mongo, flags);
				if(strcmp($a_field_name, "conn_timeout_ms") == 0) return offsetof(struct mongo, conn_timeout_ms);
				if(strcmp($a_field_name, "op_timeout_ms") == 0) return offsetof(struct mongo, op_timeout_ms);
				if(strcmp($a_field_name, "max_bson_size") == 0) return offsetof(struct mongo, max_bson_size);
				if(strcmp($a_field_name, "connected") == 0) return offsetof(struct mongo, connected);
				if(strcmp($a_field_name, "write_concern") == 0) return offsetof(struct mongo, write_concern);
				if(strcmp($a_field_name, "err") == 0) return offsetof(struct mongo, err);
				if(strcmp($a_field_name, "errcode") == 0) return offsetof(struct mongo, errcode);
				if(strcmp($a_field_name, "errstr") == 0) return offsetof(struct mongo, errstr);
				if(strcmp($a_field_name, "lasterrcode") == 0) return offsetof(struct mongo, lasterrcode);
				if(strcmp($a_field_name, "lasterrstr") == 0) return offsetof(struct mongo, lasterrstr);
				fprintf(stderr, "struct mongo.%s not found\n", (char *)$a_field_name);
				return -1;
			]"
		end

end
