class
	PD_MONGO_HOST_PORT

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			make_shared,
			structure_size,
			offset_of,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			internal_c_pointer := internal_c_pointer.memory_alloc (structure_size)
			is_allocated_memory := True
		end

	make_shared (a_c_pointer: POINTER)
		do
			internal_c_pointer := a_c_pointer
		end

	make_initialized (a_data: TUPLE [
				a_host: CE_ARRAY [INTEGER_8]
				a_port: INTEGER_32
				a_next: CE_POINTER [PD_MONGO_HOST_PORT]
			])
		require else
			a_data /= Void
		do
			make
			host.c_pointer.memory_copy (a_data.a_host.c_pointer, a_data.a_host.total_count * a_data.a_host.element_size)
			Current.port := a_data.a_port
			Current.next := a_data.a_next
		end

feature {ANY} -- fields

	host: CE_ARRAY [INTEGER_8]
		once ("OBJECT")
			create {CE_INTEGER_8_ARRAY} Result.make_shared (c__host (internal_c_pointer), <<255>>)
		end

	port: INTEGER_32 assign set__port
		do
			Result := c__port (internal_c_pointer)
		end

	next: CE_POINTER [PD_MONGO_HOST_PORT] assign set__next
		do
			create {CE_CLASS_POINTER [PD_MONGO_HOST_PORT]} Result.make_shared (c__next (internal_c_pointer))
		end

feature {ANY} -- field setters

	set__port (a_port: INTEGER_32)
		do
			c__set_port (internal_c_pointer, a_port)
		end

	set__next (a_next: CE_POINTER [PD_MONGO_HOST_PORT])
		do
			c__set_next (internal_c_pointer, a_next.c_pointer)
		end

feature {PD_MONGO_HOST_PORT} -- private attributes

	hp: CE_STATIC [CE_ARRAY [INTEGER_8]]
		once ("PROCESS")
			create Result.make (create {CE_INTEGER_8_ARRAY}.make (<<({NATURAL_32} 267).to_integer_32>>))
		end

feature {ANY} -- public routines

	get_host_port: CE_POINTER [INTEGER_8]
		do
			(create {P_SRC_BSON_STATIC}).bson_sprintf.item.call ([hp.item, ce_cstring ("%%s:%%d"), host, port])
			Result := hp.item
		end

feature {ANY}

	structure_size: INTEGER_32
		external
			"C inline use %"libmongo.h%""
		alias
			"return sizeof(struct mongo_host_port);"
		end

	structure_alignment: INTEGER_32
		external
			"C inline use %"libmongo.h%""
		alias
			"return __alignof__(struct mongo_host_port);"
		end

	offset_of (a_field_name: STRING_8): INTEGER_32
		local
			l_c_str: C_STRING
		do
			create l_c_str.make (a_field_name)
			Result := c__offset_of (l_c_str.item)
		end

feature {ANY}

	copy (a_other: like Current)
		do
			make
			internal_c_pointer.memory_copy (a_other.c_pointer, structure_size)
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result := internal_c_pointer.memory_compare (a_other.c_pointer, structure_size)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		do
			-- dummy for CE_CLASS invariant
			create Result.make_struct (<<>>)
			Result.alignment := structure_alignment
		end

	c__host (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"libmongo.h%""
		alias
			"return (EIF_POINTER)((struct mongo_host_port *)$a_c_pointer)->host;"
		end

	c__port (a_c_pointer: POINTER): INTEGER_32
		external
			"C inline use %"libmongo.h%""
		alias
			"return ((struct mongo_host_port *)$a_c_pointer)->port;"
		end

	c__next (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"libmongo.h%""
		alias
			"return (EIF_POINTER)((struct mongo_host_port *)$a_c_pointer)->next;"
		end

	c__set_port (a_c_pointer: POINTER; a_port: INTEGER_32)
		external
			"C inline use %"libmongo.h%""
		alias
			"((struct mongo_host_port *)$a_c_pointer)->port = $a_port;"
		end

	c__set_next (a_c_pointer: POINTER; a_next: POINTER)
		external
			"C inline use %"libmongo.h%""
		alias
			"((struct mongo_host_port *)$a_c_pointer)->next = $a_next;"
		end

	c__offset_of (a_field_name: POINTER): INTEGER_32
		external
			"C inline use %"libmongo.h%", <string.h>, <stddef.h>, <stdio.h>"
		alias
			"[
				if(strcmp($a_field_name, "host") == 0) return offsetof(struct mongo_host_port, host);
				if(strcmp($a_field_name, "port") == 0) return offsetof(struct mongo_host_port, port);
				if(strcmp($a_field_name, "next") == 0) return offsetof(struct mongo_host_port, next);
				fprintf(stderr, "struct mongo_host_port.%s not found\n", (char *)$a_field_name);
				return -1;
			]"
		end

end
