class
	PD_MONGO_MESSAGE

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			make_shared,
			structure_size,
			offset_of,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			internal_c_pointer := internal_c_pointer.memory_alloc (structure_size)
			is_allocated_memory := True
		end

	make_shared (a_c_pointer: POINTER)
		do
			internal_c_pointer := a_c_pointer
		end

	make_initialized (a_data: TUPLE [
				a_head: PD_MONGO_HEADER
				a_data: INTEGER_8
			])
		require else
			a_data /= Void
		do
			make
			head.c_pointer.memory_copy (a_data.a_head.c_pointer, a_data.a_head.structure_size)
			Current.data := a_data.a_data
		end

feature {ANY} -- fields

	head: PD_MONGO_HEADER assign set__head
		once ("OBJECT")
			create Result.make_shared (c__head (internal_c_pointer))
		end

	data: INTEGER_8 assign set__data
		do
			Result := c__data (internal_c_pointer)
		end

feature {ANY} -- field setters

	set__head (a_head: PD_MONGO_HEADER)
		do
			c__set_head (internal_c_pointer, a_head.c_pointer)
		end

	set__data (a_data: INTEGER_8)
		do
			c__set_data (internal_c_pointer, a_data)
		end

feature {ANY}

	structure_size: INTEGER_32
		external
			"C inline use %"libmongo.h%""
		alias
			"return sizeof(struct __anonstruct_mongo_message_15);"
		end

	structure_alignment: INTEGER_32
		external
			"C inline use %"libmongo.h%""
		alias
			"return __alignof__(struct __anonstruct_mongo_message_15);"
		end

	offset_of (a_field_name: STRING_8): INTEGER_32
		local
			l_c_str: C_STRING
		do
			create l_c_str.make (a_field_name)
			Result := c__offset_of (l_c_str.item)
		end

feature {ANY}

	copy (a_other: like Current)
		do
			make
			internal_c_pointer.memory_copy (a_other.c_pointer, structure_size)
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result := internal_c_pointer.memory_compare (a_other.c_pointer, structure_size)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		do
			-- dummy for CE_CLASS invariant
			create Result.make_struct (<<>>)
			Result.alignment := structure_alignment
		end

	c__head (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"libmongo.h%""
		alias
			"return (EIF_POINTER)&((struct __anonstruct_mongo_message_15 *)$a_c_pointer)->head;"
		end

	c__data (a_c_pointer: POINTER): INTEGER_8
		external
			"C inline use %"libmongo.h%""
		alias
			"return ((struct __anonstruct_mongo_message_15 *)$a_c_pointer)->data;"
		end

	c__set_head (a_c_pointer: POINTER; a_head: POINTER)
		external
			"C inline use %"libmongo.h%""
		alias
			"((struct __anonstruct_mongo_message_15 *)$a_c_pointer)->head = *(struct __anonstruct_mongo_header_14 *)$a_head;"
		end

	c__set_data (a_c_pointer: POINTER; a_data: INTEGER_8)
		external
			"C inline use %"libmongo.h%""
		alias
			"((struct __anonstruct_mongo_message_15 *)$a_c_pointer)->data = $a_data;"
		end

	c__offset_of (a_field_name: POINTER): INTEGER_32
		external
			"C inline use %"libmongo.h%", <string.h>, <stddef.h>, <stdio.h>"
		alias
			"[
				if(strcmp($a_field_name, "head") == 0) return offsetof(struct __anonstruct_mongo_message_15, head);
				if(strcmp($a_field_name, "data") == 0) return offsetof(struct __anonstruct_mongo_message_15, data);
				fprintf(stderr, "struct __anonstruct_mongo_message_15.%s not found\n", (char *)$a_field_name);
				return -1;
			]"
		end

end
