#ifndef LIBMONGO_H
#define LIBMONGO_H

#include <ffi.h>
#include <mingw_inc/_ip_types.h>
#include <mingw_inc/_wsadata.h>
#include <ws2tcpip.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <winsock2.h>
#include <time.h>

#undef count
#undef abcd
#undef buf
#undef cur
#undef first
#undef data
#undef dataSize
#undef finished
#undef stack
#undef stackPos
#undef err
#undef errstr
#undef len
#undef id
#undef responseTo
#undef op
#undef head
#undef flag
#undef cursorID
#undef start
#undef num
#undef fields
#undef objs
#undef host
#undef port
#undef next
#undef w
#undef wtimeout
#undef j
#undef fsync
#undef mode
#undef cmd
#undef seeds
#undef hosts
#undef name
#undef primary_connected
#undef primary
#undef replset
#undef sock
#undef flags
#undef conn_timeout_ms
#undef op_timeout_ms
#undef max_bson_size
#undef connected
#undef write_concern
#undef errcode
#undef lasterrcode
#undef lasterrstr
#undef reply
#undef conn
#undef ns
#undef seen
#undef current
#undef query
#undef options
#undef limit
#undef skip
#undef sa_family
#undef sa_data
#undef wVersion
#undef wHighVersion
#undef szDescription
#undef szSystemStatus
#undef iMaxSockets
#undef iMaxUdpDg
#undef lpVendorInfo
#undef ai_flags
#undef ai_family
#undef ai_socktype
#undef ai_protocol
#undef ai_addrlen
#undef ai_canonname
#undef ai_addr
#undef ai_next
#undef _ptr
#undef _cnt
#undef _base
#undef _flag
#undef _file
#undef _charbuf
#undef _bufsiz
#undef _tmpfname
#undef bytes
#undef ints
#undef client
#undef dbname
#undef prefix
#undef files_ns
#undef chunks_ns
#undef gfs
#undef meta
#undef pos
#undef remote_name
#undef content_type
#undef length
#undef chunk_num
#undef pending_data
#undef pending_len
#undef i
#undef t
#undef memcpy
#undef _Dst
#undef _Src
#undef _Size
#undef atoi
#undef _Str
#undef rand
#undef free
#undef _Memory
#undef memset
#undef _Val
#undef strcpy
#undef _Dest
#undef _Source
#undef strcmp
#undef _Str1
#undef _Str2
#undef strlen
#undef strchr
#undef strncpy
#undef _Count
#undef closesocket
#undef s
#undef connect
#undef namelen
#undef recv
#undef send
#undef setsockopt
#undef level
#undef optname
#undef optval
#undef optlen
#undef socket
#undef af
#undef type
#undef protocol
#undef WSAStartup
#undef wVersionRequested
#undef lpWSAData
#undef WSAGetLastError
#undef getaddrinfo
#undef nodename
#undef servname
#undef hints
#undef res
#undef freeaddrinfo
#undef pAddrInfo
#undef time
#undef _Time
#undef strcat
#undef fclose
#undef _File
#undef fopen
#undef _Filename
#undef _Mode
#undef fread
#undef _DstBuf
#undef _ElementSize
#undef fwrite
#undef exit
#undef _Code
#undef srand
#undef _Seed
#undef malloc
#undef realloc
#undef _NewSize
#undef fprintf
#undef _Format
#undef printf
#undef vfprintf
#undef _ArgList
#undef sprintf

enum PC_BSON_TYPE {
	BSON_EOO = 0,
	BSON_DOUBLE = 1,
	BSON_STRING = 2,
	BSON_OBJECT = 3,
	BSON_ARRAY = 4,
	BSON_BINDATA = 5,
	BSON_UNDEFINED = 6,
	BSON_OID = 7,
	BSON_BOOL = 8,
	BSON_DATE = 9,
	BSON_NULL = 10,
	BSON_REGEX = 11,
	BSON_DBREF = 12,
	BSON_CODE = 13,
	BSON_SYMBOL = 14,
	BSON_CODEWSCOPE = 15,
	BSON_INT = 16,
	BSON_TIMESTAMP = 17,
	BSON_LONG = 18
};
enum PC_MONGO_ERROR_T {
	MONGO_CONN_SUCCESS = 0,
	MONGO_CONN_NO_SOCKET = 1,
	MONGO_CONN_FAIL = 2,
	MONGO_CONN_ADDR_FAIL = 3,
	MONGO_CONN_NOT_MASTER = 4,
	MONGO_CONN_BAD_SET_NAME = 5,
	MONGO_CONN_NO_PRIMARY = 6,
	MONGO_IO_ERROR = 7,
	MONGO_SOCKET_ERROR = 8,
	MONGO_READ_SIZE_ERROR = 9,
	MONGO_COMMAND_FAILED = 10,
	MONGO_WRITE_ERROR = 11,
	MONGO_NS_INVALID = 12,
	MONGO_BSON_INVALID = 13,
	MONGO_BSON_NOT_FINISHED = 14,
	MONGO_BSON_TOO_LARGE = 15,
	MONGO_WRITE_CONCERN_INVALID = 16
};
enum PC_MONGO_CURSOR_ERROR_T {
	MONGO_CURSOR_EXHAUSTED = 0,
	MONGO_CURSOR_INVALID = 1,
	MONGO_CURSOR_PENDING = 2,
	MONGO_CURSOR_QUERY_FAIL = 3,
	MONGO_CURSOR_BSON_ERROR = 4
};

struct mongo_md5_state_s;
struct __anonstruct_bson_iterator_10;
struct __anonstruct_bson_11;
struct __anonstruct_mongo_header_14;
struct __anonstruct_mongo_message_15;
struct __anonstruct_mongo_reply_fields_16;
struct __anonstruct_mongo_reply_17;
struct mongo_host_port;
struct mongo_write_concern;
struct __anonstruct_mongo_replset_18;
struct mongo;
struct __anonstruct_mongo_cursor_19;
union __anonunion_bson_oid_t_12;
struct __anonstruct_gridfs_21;
struct __anonstruct_gridfile_22;
struct __anonstruct_bson_timestamp_t_13;

typedef struct __anonstruct_bson_iterator_10 bson_iterator;
typedef struct __anonstruct_bson_11 bson;
typedef struct __anonstruct_mongo_header_14 mongo_header;
typedef struct __anonstruct_mongo_message_15 mongo_message;
typedef struct __anonstruct_mongo_reply_fields_16 mongo_reply_fields;
typedef struct __anonstruct_mongo_reply_17 mongo_reply;
typedef struct __anonstruct_mongo_replset_18 mongo_replset;
typedef struct __anonstruct_mongo_cursor_19 mongo_cursor;
typedef union __anonunion_bson_oid_t_12 bson_oid_t;
typedef struct __anonstruct_gridfs_21 gridfs;
typedef struct __anonstruct_gridfile_22 gridfile;
typedef struct __anonstruct_bson_timestamp_t_13 bson_timestamp_t;

#pragma pack(1)
struct __anonstruct_mongo_header_14 {
	int len;
	int id;
	int responseTo;
	int op;
};
struct __anonstruct_mongo_message_15 {
	mongo_header head;
	char data;
};
struct __anonstruct_mongo_reply_fields_16 {
	int flag;
	long long cursorID;
	int start;
	int num;
};
struct __anonstruct_mongo_reply_17 {
	mongo_header head;
	mongo_reply_fields fields;
	char objs;
};
union __anonunion_bson_oid_t_12 {
	char bytes[12];
	int ints[3];
};
#pragma pack()

struct mongo_md5_state_s {
	unsigned int count[2];
	unsigned int abcd[4];
	unsigned char buf[64];
};
struct __anonstruct_bson_iterator_10 {
	char const * cur;
	int first;
};
struct __anonstruct_bson_11 {
	char * data;
	char * cur;
	int dataSize;
	int finished;
	int stack[32];
	int stackPos;
	int err;
	char * errstr;
};
struct mongo_host_port {
	char host[255];
	int port;
	struct mongo_host_port * next;
};
struct mongo_write_concern {
	int w;
	int wtimeout;
	int j;
	int fsync;
	char const * mode;
	bson * cmd;
};
struct __anonstruct_mongo_replset_18 {
	struct mongo_host_port * seeds;
	struct mongo_host_port * hosts;
	char * name;
	int primary_connected;
};
struct mongo {
	struct mongo_host_port * primary;
	mongo_replset * replset;
	int sock;
	int flags;
	int conn_timeout_ms;
	int op_timeout_ms;
	int max_bson_size;
	int connected;
	struct mongo_write_concern * write_concern;
	unsigned int err;
	int errcode;
	char errstr[128];
	int lasterrcode;
	char lasterrstr[128];
};
struct __anonstruct_mongo_cursor_19 {
	mongo_reply * reply;
	struct mongo * conn;
	char const * ns;
	int flags;
	int seen;
	bson current;
	unsigned int err;
	bson * query;
	bson * fields;
	int options;
	int limit;
	int skip;
};
struct __anonstruct_gridfs_21 {
	struct mongo * client;
	char const * dbname;
	char const * prefix;
	char const * files_ns;
	char const * chunks_ns;
};
struct __anonstruct_gridfile_22 {
	gridfs * gfs;
	bson * meta;
	unsigned long long pos;
	bson_oid_t id;
	char * remote_name;
	char * content_type;
	unsigned long long length;
	int chunk_num;
	char * pending_data;
	int pending_len;
};
struct __anonstruct_bson_timestamp_t_13 {
	int i;
	int t;
};

#endif
